function[spl,strouhal,r,theta,DI,beta_rad]=liftoff_step7(freq,de,U,samp,Lwb,ilast,igeo,xs,iw,stationdiam,cspeed,x1,rho)
%
%  liftoff_step7.m, ver 1.0  April 19,2005
%
	c1_an(1)=  20.;	
	c1_an(2)=	28.;	
	c1_an(3)=	32.;	
	c1_an(4)=	40.;	
	c1_an(5)=	60.;
	c1_an(6)=	80.;	
	c1_an(7)=	100.;	
	c1_an(8)=	140.;	
	c1_an(9)=	150.;	
	c1_an(10)=	160.;	
	c1_an(11)=  180.; 
%
	c1_dn(1)=	3.5;
	c1_dn(2)=	7.5;
	c1_dn(3)=	7.5;
	c1_dn(4)=	6.;
	c1_dn(5)=	0.65;
	c1_dn(6)=	-4.5;
	c1_dn(7)=	-9.;
	c1_dn(8)=	-14.;
	c1_dn(9)=	-15.;
	c1_dn(10)=	-16.;
	c1_dn(11)=	-17.2;
%
	c2_an(1)=  20.;	
	c2_an(2)=	30.;	
	c2_an(3)=	32.;	
	c2_an(4)=	38.;	
	c2_an(5)=	40.;
	c2_an(6)=	43.;	
	c2_an(7)=	60.;	
	c2_an(8)=	100.;	
	c2_an(9)=	140.;	
	c2_an(10)=	160.;	
	c2_an(11)=  180.; 
%
	c2_dn(1)=	0.;
	c2_dn(2)=	3.5;
	c2_dn(3)=	6.0;
	c2_dn(4)=	6.3;
	c2_dn(5)=	6.0;
	c2_dn(6)=	2.5;
	c2_dn(7)=	-7.5;
	c2_dn(8)=	-13.5;
	c2_dn(9)=	-15.5;
	c2_dn(10)=	-16.;
	c2_dn(11)=	-17.;
%
	c3_an(1)=  20.;	
	c3_an(2)=	30.;	
	c3_an(3)=	40.;	
	c3_an(4)=	48.;	
	c3_an(5)=	52.;
	c3_an(6)=	60.;	
	c3_an(7)=	100.;	
	c3_an(8)=	120.;	
	c3_an(9)=	140.;	
	c3_an(10)=	160.;	
	c3_an(11)=  180.; 
%
	c3_dn(1)=	-1.;
	c3_dn(2)=	2.1;
	c3_dn(3)=	5.0;
	c3_dn(4)=	5.5;
	c3_dn(5)=	5.5;
	c3_dn(6)=	3.5;
	c3_dn(7)=	-7.;
	c3_dn(8)=	-9.9;
	c3_dn(9)=	-12.5;
	c3_dn(10)=	-14.5;
	c3_dn(11)=	-16.;
%
	c4_an(1)=  20.;	
	c4_an(2)=	30.;	
	c4_an(3)=	40.;	
	c4_an(4)=	50.;	
	c4_an(5)=	60.;
	c4_an(6)=	100.;	
	c4_an(7)=	120.;	
	c4_an(8)=	140.;	
	c4_an(9)=	160.;	
	c4_an(10)=	160.;	
	c4_an(11)=  180.; 
%
	c4_dn(1)=	-2.;
	c4_dn(2)=	1.5;
	c4_dn(3)=	3.5;
	c4_dn(4)=	5.0;
	c4_dn(5)=	4.0;
	c4_dn(6)=	-5.5;
	c4_dn(7)=	-9.;
	c4_dn(8)=	-11.5;
	c4_dn(9)=	-12.8;
	c4_dn(10)=	-13.4;
	c4_dn(11)=	-14.;
%
	c5_an(1)=  20.;	
	c5_an(2)=	30.;	
	c5_an(3)=	40.;	
	c5_an(4)=	57.;	
	c5_an(5)=	60.;
	c5_an(6)=	80.;	
	c5_an(7)=	100.;	
	c5_an(8)=	120.;	
	c5_an(9)=	140.;	
	c5_an(10)=	160.;	
	c5_an(11)=  180.; 
%
	c5_dn(1)=	-2.5;
	c5_dn(2)=	0.9;
	c5_dn(3)=	2.8;
	c5_dn(4)=	4.;
	c5_dn(5)=	4.;
	c5_dn(6)=	1.;
	c5_dn(7)=	-4.;
	c5_dn(8)=	-8.;
	c5_dn(9)=	-10.;
	c5_dn(10)=	-12.;
	c5_dn(11)=	-13.;
%
% disp(' ');
% disp(' freq(Hz)  d1  d2  d3  d4  d5  k1 k2 DI');
%
iii=length(samp);
for(i=1:iii)
%
    r(i)=0.;
    theta(i)=180.;	
    DI(i)=0.;
    beta_rad(i)=0.;
%    
    d1=0.;
    d2=0.;
    d3=0.;
    d4=0.;
    d5=0.;
%    
    strouhal(i) = freq(i)*de/U;
%
    if(igeo==1 | igeo==2 | igeo==3)  % undeflected
%
			r(i)=xs+samp(i);    % samp(i) is apparent source allocation position
%       
    else   % deflected
%
			x2= samp(i) -x1;
%
			if(x2 > 0. )    
%			
				ry= (xs+x1)-samp(i)*sin(pi*rho/180.);
				rx= x2*cos(pi*rho/180.);
				r(i)=sqrt( (rx^2.) + (ry^2.) );
%
				beta_rad(i) = atan2(ry,rx);
				beta_deg(i) = 180.*beta_rad(i)/pi;
%
				theta(i) = 180. - rho - beta_deg(i);   
%
			else   % special case where source occurs before deflection
%		
				r(i) = xs + samp(i);
                theta(i) = 180.;
     			beta_rad(i) = atan2(1,0);           
%          
            end
    end
%
    if(theta(i)>180.)
        theta(i)=180.;
    end
    if(theta(i)< 20.)
        theta(i)= 20.;
    end
%
%  directivity()
%	
	for(jk=1:10)
%	
		if(theta(i) >= c1_an(jk) & theta(i) <= c1_an(jk+1) )
%		
			len=c1_an(jk+1)-c1_an(jk);
			k2= (theta(i)   -c1_an(jk))/len;
%
			k1=1.-k2;
			d1 = k1*c1_dn(jk) + k2*c1_dn(jk+1);
%
			break;
        end     
    end
%
	for(jk=1:10)
%	
		if(theta(i)>= c2_an(jk) & theta(i)<= c2_an(jk+1) )
%		
			len=c2_an(jk+1)-c2_an(jk);
			k2= (theta(i)  -c2_an(jk))/len;
%
			k1=1.-k2;
			d2 = k1*c2_dn(jk) + k2*c2_dn(jk+1);
%
			break;
        end
    end
%
	for(jk=1:10)
%	
		if(theta(i)>= c3_an(jk) & theta(i)<= c3_an(jk+1) )
%		
			len=c3_an(jk+1)-c3_an(jk);
			k2= (theta(i)  -c3_an(jk))/len;
%
			k1=1.-k2;
			d3 = k1*c3_dn(jk) + k2*c3_dn(jk+1);
%
			break;
        end
    end
%
	for(jk=1:10)
%	
		if(theta(i)>= c4_an(jk) & theta(i)<= c4_an(jk+1) )
%		
			len=c4_an(jk+1)-c4_an(jk);
			k2= (theta(i)  -c4_an(jk))/len;
%
			k1=1.-k2;
			d4 = k1*c4_dn(jk) + k2*c4_dn(jk+1);
%
			break;
        end
    end
%
	for(jk=1:10)
%	
		if(theta(i)>= c5_an(jk) & theta(i)<= c5_an(jk+1) )
%		
			len=c5_an(jk+1)-c5_an(jk);
			k2= (theta(i)  -c5_an(jk))/len;
%
			k1=1.-k2;
			d5 = k1*c5_dn(jk) + k2*c5_dn(jk+1);
%
			break;
        end
    end
%
	m1= 0.004;
	m2= 0.0125;
	m3= 0.04;
	m4= 0.125;
	m5= 0.4;
%   
    clear k1;
    clear k2;
    k1=0.;
    k2=0.;
%
    if(strouhal(i)<= m1)
%	
		DI(i) =d1;
%
    end
    if(strouhal(i)> m1  & strouhal(i)<= m2)
%	
		len=m2-m1;
		k2=(strouhal(i)-m1)/len;
    	k1=1.-k2;    
		DI(i) = k1*d1 + k2*d2;
%
%		fprintf(pFile(1),' %12.3e %12.3e %12.3e\n',strouhal,theta,DI(i));
    end
    if(strouhal(i)> m2 & strouhal(i)<= m3)
%	
		len=m3-m2;
		k2=(strouhal(i)-m2)/len;
		k1=1.-k2;
		DI(i) = k1*d2 + k2*d3;
%
%		fprintf(pFile(1),' %12.3e %12.3e %12.3e\n',strouhal,theta,DI(i));
    end
    if(strouhal(i)> m3   & strouhal(i)<= m4)
%	
		len=m4-m3;
		k2=(strouhal(i)-m3)/len;
		k1=1.-k2;
		DI(i) = k1*d3 + k2*d4;
%
%		fprintf(pFile(1),' %12.3e %12.3e %12.3e\n',strouhal,theta,DI(i));
    end
    if(strouhal(i)> m4  & strouhal(i)<= m5)
%
		len=m5-m4;
		k2=(strouhal(i)-m4)/len;
		k1=1.-k2;
		DI(i) = k1*d4 + k2*d5;

%		fprintf(pFile(1),' %12.3e %12.3e %12.3e\n',strouhal,theta,DI(i));
    end
	if(strouhal(i)> m5)
		DI(i) =d5;

%		fprintf(pFile(1),' %12.3e %12.3e %12.3e\n',strouhal,theta,DI(i));
    end
%
    spl(i)=Lwb(i)-10.*log10((r(i)^2.)) -11. +DI(i);
%
%	out1=sprintf(' %10.3f %4.1f %4.1f %4.1f %4.1f %4.1f %5.2f %5.2f %5.2f',freq(i),d1,d2,d3,d4,d5,k1,k2,DI(i));
%    disp(out1);
end
% disp(' ');