function[isys,F,U,dei,aceff,cspeed,N,iw] = liftoff_input_data(m_per_ft)
%
%  liftoff_input_data.m, ver 1.0,	April 19, 2005
%
disp(' ');
disp(' Select system');
disp(' 1=English  2=metric ');
isys=input('');
%
if(isys ~=1 & isys ~=2 )
    isys=1;
end
%
if(isys==1)
    disp(' Enter thrust (lbf) ');
else
    disp(' Enter thrust (N) ');
end
%
F=input('');
%
if(isys==1)
    F=F*4.4484; 
end
%
if(isys==1)
    disp('  Enter exhaust exit velocity (ft/sec)');
else
    disp('  Enter exhaust exit velocity (m/sec)');
end    
U=input('');
%
if(isys==1)
    U=U*m_per_ft; 
end
%
if(isys==1)
    disp('  Enter speed of sound (ft/sec)   Typical speed = 1120 ft/sec ');
else
    disp('  Enter speed of sound (m/sec)    Typical speed = 343 m/sec ');
end
cspeed=input('');
%
if(isys==1)
    cspeed=cspeed*m_per_ft; 
end
%
disp('  Enter acoustic efficiency in decimal format.   (Conservative value = 0.01) ');
aceff=input('');
%
if(isys==1)
    disp('  Enter nozzle diameter (inches)');
else
    disp('  Enter nozzle diameter (m)');
end
dei=input('');
%
if(isys==1)
    dei=dei*m_per_ft/12.; 
end
%
disp('  Enter number of nozzles ');
N=input('');
%
disp(' ')
disp(' Apply Wilby correction factor for surface reflections? ');
disp(' 1=yes  2=no ');
iw=input('');